'Nouveau Programme de Batteries 16f873
asm
org 0x2007
dw 0x3F36
end asm 

asm
org 0x2100    
dw 0x6     ;Correction de la tension batterie
dw 0x2     ;Coficient pour le nombre de boucles de ADC 
dw 0x0     ;Nb de plantages
dw 0x0
end asm

'#interrupt

Include "16F873.inc"       'Programme pour PIC16F876
Include "I2cSoft.bas"
Include "Lcd_bat.bas"
Include "24C04.bas"

'Dclaration du programme principal
Bit Signe     AT PORTA.2
'Bit d1    AT PORTC.0  ' horloge
'Bit d2    AT PORTC.1  ' horloge 
Bit d1    AT PORTC.2
Bit d2    AT PORTC.5
Bit d3    AT PORTC.6
Bit d4    AT PORTC.7
Bit BlLight   AT PORTB.0
Bit Bp_Ok     AT PORTB.3
Bit Bp_m      AT PORTA.4
Bit Bp_p      AT PORTA.5
Byte d,e,f,compt,ind1,ind2
Byte adc_canal,i,coef,tension
Word r,adcmoy,moyvolt,moyamp
Word v,v0,v1,v2
Byte corect,lig,col,touche  
Byte seconde,minute,heure,jour,mois,year
Declare Function ADC(adc_canal) As Word   'type word car conversion sur 10 bits
Declare Sub Accueil()
Declare Sub ProgInit()
Declare Sub MesureTension()
Declare Sub Traitement_Tension_Batterie(m)
Declare Sub MesureAmpere()
Declare Sub TestClavier()
Declare Sub Plantation()
Declare Sub Menu_General()

Declare Function AJUST_VAR(a, b,c,lig,col) as byte 
Declare Function QuelTouch() AS Byte      
Declare Sub ReglageHorlog()
Declare Sub ReglageVolt()
Declare Sub regBoucle()    
Declare Sub TraitementInt()
Declare Sub Timer1Init()
Declare Sub Reaffichage()
Declare Sub TestDatas()
Declare Sub BasculTension() 

  
debut:
       pause 100
       asm clrwdt  ;un os au Chien          
       LcdInit
       ProgInit()  ' Initialisation de l'ADC, WatchDog,
       I2cInit()
       asm clrwdt  ;un os au Chien          
       LcdClear 
       Accueil()
       asm clrwdt  ;un os au Chien          
       Input Bp_Ok
       Input Bp_m
       Input Bp_p
       Input Signe 
       Output d1
       Output d2
       Output d3
       Output d4
       Output BlLight
       LcdClear()
       If I2CStatus <> 0 then locate 1,1:Print " ERREUR I2C",I2CStatus Else print " I2C OK ":Pause 600
       LcdClear
' =======================================================================================================================
boucle:
       MesureTension()  ' mesure et affiche la valeur de la tension en ligne 1
       MesureAmpere()   ' mesure et affiche l'intensit dans le shunt de 100Amp aprs convertion 
       asm clrwdt  ;un os au Chien           
       TestClavier()    ' Contrle si touche clavier appuy
       If ind1 > 0 then ind1=ind1 -1 : pause 2    ''  pour le shunt 1 plus efficace
       If ind2 > 0 then ind2=ind2 -1 : pause 2    ''  pour le shunt 2 plus efficace

       goto boucle

' =======================================================================================================================

Sub ProgInit()
       ' Initialisation de l'ADC 
       ADCS1=1 : ADCS0=0                     ' horloge 20 Mhz Frquence maxi quartz 20Mhz
       PCFG2=1 : PCFG1=0 :PCFG0=0                     'Sans Ref en RA3 de 2.5v
       ADFM=1                                ' justification  droite  
       ADON=1                                ' mise en route convertisseur
     
       ' ****** Pour Mdor *******************
       PSA=1 ' Timer 0 assign au WatchDog
       PS0=1 ' Division par 128  = 1 1 1  
       PS1=1 '               64  = 1 1 0 
       PS2=1 '               16  = 1 0 0
       seconde = 0:minute = 0:heure = 0:jour = 0:mois = 0:year = 4 
       asm clrwdt  ;un os au Chien               
       coef = EERead (0)  Rem lit la cellue 1 et place son contenu dans la variable coef  
       compt = EERead(1)  Rem lire le Nb de Boucles ADC 
       tension = EERead(3)    '' lire cellule 3 pour 12 ou 24V
      
       
End Sub

'Interrupt:
    'sauvegerder les registres
   ' _R0_TEMP = _R0
   ' _R1_TEMP = _R1
   ' _R2_TEMP = _R2
   ' _R3_TEMP = _R3
  '  _R4_TEMP = _R4
   ' _R5_TEMP = _R5
   ' _R6_TEMP = _R6
   ' _R7_TEMP = _R7
   ' _R8_TEMP = _R8
   ' _R9_TEMP = _R9
   ' _c_TEMP_tmp = c_tmp
     rem --------------------------- code interruptions ----------------------------
  '   If TMR1IF = 1 then TraitementInt 'si Interruption 
       
     rem ----------------------------- fin code interruption ----------------------
'InterruptEnd:
 '    'Fin code interruptionrstaurer les registres
 '    _R0 = _R0_TEMP
 '    _R1 = _R1_TEMP
 '    _R2 = _R2_TEMP
 '    _R3 = _R3_TEMP
 '    _R4 = _R4_TEMP
 '    _R5 = _R5_TEMP
 '    _R6 = _R6_TEMP
 '    _R7 = _R7_TEMP
 '    _R8 = _R8_TEMP
  '   _R9 = _R9_TEMP
   '  c_tmp = _c_TEMP_tmp
  '   asm movf _FSR_TEMP,0
  '   asm movwf FSR
  '   asm movf _PCLATH_TEMP,0
    ' asm movwf PCLATH
    ' asm swapf _STATUS_TEMP,0
    ' asm movwf STATUS
    ' asm swapf _W_TEMP,1
    ' asm swapf _W_TEMP,0
   '  Reti


Sub TraitementInt()
     TMR1H = 0x80    'on recharge le registre timer1 High avec 80h noter que TMR1L a dbut comptage
     TMR1IF = 0      ' remise  0 du drapeau d'interruption du timer1
     asm clrwdt  ;un os au Chien 
     seconde = seconde + 1
     IF seconde = 60 Then
        seconde = 0:minute = minute + 1
        If minute = 60 Then minute = 0:heure = heure + 1
     End IF
     Locate 2,1:print heure
     Locate 2,3:print "h",minute
     locate 2,6:print "mn"
     
End sub


Sub Timer1Init()
       TMR1ON = 0 'stoppe le timer1 = arrte le comptage (au cas o il ne le serait pas..)
        '**** configuration du mode de fonctionnement du timer1***
       TMR1CS = 1 'Clock Select : source de comptage externe
       T1SYNC = 1 'mode asynchrone
       T1OSCEN = 1 'utilisation d'un quartz (met PC0 et PC1 en entre automatiquement)ici 32,768khz
       T1CKPS1 = 0: T1CKPS0 = 0 'facteur de prdivision (prescaler) = 1/1
       TMR1L = 0 'initialise le timer avec la valeur 8000 (16bits dans les 2 registres L et H)
       TMR1H=0x80 'le comptage dmarrera avec cette valeur => d'o overflow aprs 1 seconde
       '**** activation des interruptions pour timer1 ****
       TMR1IF = 0 'met le drapeau d'interruption du timer1  0
       'TMR1IE = 1 'autorise l'interruption du timer1
       PEIE = 1 'autorise les interruptions priphriques (dont overflow timer1 fait partie)
       '****** lancement du comptage *********
       TMR1ON = 1 'active le timer1 = dbut du comptage

End sub


'--------------------------------------------------------------------------
                    org 0x0800,0x0FFF  'page 1 ****************************
'--------------------------------------------------------------------------



Function ADC(Byte ch) As Word             'ch = canal
   Static Word r
   ADIF=0
     rem Il faut introduire un
     rem temps d'acquisition (env. 19 S d'aprs Microchip) entre l'aiguillage du
     rem canal ( CHS0  2 ) et le lancement de la mesure...
   If ch = 0 Then CHS1 = 0 : CHS0 = 0     'configuration suivant le canal 
   Pause 10
   If ch = 1 Then CHS1 = 0 : CHS0 = 1
   Pause 10
   If ch = 2 Then CHS1 = 1 : CHS0 = 0
   Pause 10
   If ch = 3 Then CHS1 = 1 : CHS0 = 1
   Pause 10
   GO_DONE = 1
   REM DO WHILE ADIF=0 AND n<>0
   Do While GO_DONE = 1                   'attendre fin conversion
   Loop
   'transformer 2 octets en une valeur sur 16 bits de type word
   r = ADRESh         
   Swap r
   r = r+ADRESL
   Return (r)
   End Function


Sub MesureTension()
     ' ----------------- Mesure de la tension ----------------------------
     'Conversion  10 bits De la tension Batterie et Affichage en ligne 1
     adcmoy=0
     for i = 1 to compt 'compt dtermine le nombre de mesure pour la moyenne 
          asm clrwdt  ;un os au Chien                  
          r = ADC(3)
          adcmoy = adcmoy + r 'somme des relevs pour calcul moyenne
     next i
     r = adcmoy /compt    ' 10 Mesures pour un bon rsultat 
         v0 = r / coef       ' Ajustage Corection des composants ajout de 1/18 me de r  r par v0
     asm clrwdt  ;un os au Chien                  
     if moyvolt > r + 2 or moyvolt < r - 2  then ' Pour affichage en cas de diffrence de 2 
        Traitement_Tension_Batterie(r)  'Commutes 1 des 4 Sorties  
        moyvolt = r
        r = (r * 34)/10  ' Multiplication Tension X 3.3
        r = r + v0
        v = 5* r
        asm clrwdt  ;un os au Chien                  
        If r < 500 Then v = v - (115 * r) / 1000  Else r = r /2 : r = (115 * r) / 1000 :  v = v - r - r
        If tension = 2 Then v=v/5 Else v=v/10   '' si tension = 2 on est en 24V 
        v0 = v /100
        v1 = v0
        v0 = v0 * 100
        v0 = v - v0
        Locate 1,1
        Print v1,"."
        Locate 1,4
        if v0 < 10 then print "0", v0 else print v0
        Locate 1,6:print "V"
     End if
End Sub     

Sub MesureAmpere()
     ' ----------------- Mesure intensit --------------------------------
     adcmoy=0
     for i=1 to compt 'compt dtermine le nombre de mesure pour la moyenne 
     asm clrwdt  ;un os au Chien                  
     if Signe = 1 then r = ADC(1) else r = ADC(0)
     adcmoy=adcmoy+r 'somme des relevs pour calcul moyenne
     next i
     r = adcmoy/compt
     if moyamp > r or moyamp < r then
        moyamp = r
        v = 5* r 
        asm clrwdt  ;un os au Chien                  
        If r<500 then v=v-(115*r)/1000 else r=r/2:r=(115*r)/1000:v=v-r-r
        v=v*2        '' MAX 4376 F *2 Gain de 50 au lieu de 100
        v0 = v /60
        v1 = v0 * 60 
        v2 = v - v1
        v2 = v2 * 10
        v2 = v2 / 60
        Locate 1,8             '' Mme ligne que la tension 
        if Signe = 1 then print "+" else print "-"
        Locate 1,9
        Print v0,".",v2,"Amp"
     End if
End Sub 

Sub TestClavier()
    If Bp_m = 0 and Bp_p = 0 Then          '  Moins et Ok    Allez au menu gnral
        PauseButton()
        Do While Bp_m = 0 and Bp_p = 0 
        asm clrwdt
        PauseButton()
        Menu_General()
        Loop
    End if
   
     If Bp_p = 0 and Bp_Ok = 0 then   ' + et Ok
        PauseButton()
        Do While Bp_p = 0 and Bp_Ok = 0 
        asm clrwdt
        PauseButton()
        BasculTension()   ' Commute 12  24V et enregistre valeur en EEprom
        Loop
     End if 
     
     If Bp_m = 0 and Bp_Ok = 0 then      ' moins et Ok
        PauseButton()
        Do While Bp_m = 0 and Bp_Ok = 0
        PauseButton()
        LcdClear
        Print " je plante"
        Plantation()                     ' test de plantation pour le chien       
        '' pour une autre application
        Loop
     End if
End Sub

Sub Plantation()
    static byte k
    k=2
    Do While k=2  ' Impossible !!!
    Loop
End Sub

Sub Reaffichage()
    LcdClear
    moyvolt=55  ' Valeur impossible pour forcer le raffichage
    moyamp=55   ' Valeur impossible pour forcer le raffichage
    
    'VoirHorloge()
End Sub

'--------------------------------------------------------------------------
                   org 0x1000,0x17FF       'page 2 ************************ 
' -------------------------------------------------------------------------

Sub Traitement_Tension_Batterie(word volt)
       
      '' Tension Minimum DANGER 11,65V (23,30V=654                        721=25,64V  727=28,85V  730=25,95V     760=27,00V 
      '' Tension de Floating 13,20V (26.37)=742  et 13,80V (27,58) =777                 754=26,78V  757=26,99V
      '' Tension Maxi de Charge normale    13,80V (27,58V) = 777           773=27,45V  781=27,73   776=27,56
      '' Tension d'EGALISATION  14,10V ou 28,20V = 795                      654=23,30V 
     
      asm clrwdt  ;un os au Chien 
      'locate 2,1:print "ADC:",volt
      rem on commence par la lumire 
      if volt >670 then d1=1:Locate 2,1:print "A1" '11,60 V
      if volt <660 then d1=0:Locate 2,1:print "A0" '11,57 V

      rem convertisseur 150w 
      if volt >675 then d2=1 :Locate 2,4:print "B1" '000 V
      if volt <670 then d2=0 :Locate 2,4:print "B0" '000 V
      asm clrwdt  ;un os au Chien            
      Rem 1er Shuntage 28V
      if volt >770 then d3=1 :Locate 2,7:print "C1":ind1=255   ' 28,00 V
      if volt <765 and ind1=0 then d3=0 :Locate 2,7:print "C0"'

      Rem 2me shuntage 27,58V
      if volt >775 then d4=1 :Locate 2,10:print "D1" :ind2=255 ' 13,80 ou 27,58V
      if volt <770 and ind2=0 then d4=0 :Locate 2,10:print "D0"  
     
      asm clrwdt  ;un os au Chien
      locate 2,13:print volt   '' pour voir provisoirement la valeur de ADC
            
      
End Sub

Sub BasculTension()       '' Permettre de travailler en 12 V ou en 24V
    LcdClear
    Locate 1,1:Print "Choix 12 ou 24 V" 
    Locate 2,1:Print "Ok Chang Anul+/-"
    PauseButton()
    QuelTouch()
    If touche = 3 Then ' Touche OK   rglage tension batterie 
       LcdClear
       Locate 1,1:Print "12V = - /24V = +" 
       touche = 0
       QuelTouch()
       Select touche
            Case 1: tension = 0 :EEWrite(3,tension)  ' 12V
            Case 2: tension = 2 :EEWrite(3,tension)  ' 24V
       End Select
    End If
       Reaffichage():Goto Boucle  ' on quitte
    End Sub               
 
 
Sub Menu_General()
    LcdClear
    Locate 1,1:Print "Reg Horloge=OK" 
    Locate 2,1:Print "Suite Menu + / -"
    QuelTouch()
    If touche = 3 Then ReglageHorlog()    ' Touche OK   rglage heure
    If touche = 1 or 2 Then LcdClear
    Locate 1,1:Print " Ajuste Volt=OK " 
    Locate 2,1:Print "Suite Menu + / -"
    QuelTouch()
    If touche = 3 Then  ReglageVolt()
    If touche = 1 or 2 Then LcdClear
    Locate 1,1:Print "Reglag Boucle=Ok" 
    Locate 2,1:Print "Suite Menu + / -"
    QuelTouch()
    If touche = 3 Then  regBoucle()
    If touche = 1 or 2 Then LcdClear
    Locate 1,1:Print "Fin des Reglages" 
    Locate 2,1:Print " +/-/OK  Retour "
    QuelTouch()
    Reaffichage()
    Goto Boucle
End Sub

Sub ReglageVolt()    '' Rglage de l'ajustement de la tension de la batterie
    LcdClear   
    Locate 1,1:Print"Reglage X Volts"
    Locate 2,1:Print "X par :"
    AJUST_VAR(coef,100,5,2,9)
    coef = corect 
    EEwrite(0,coef)
    pause 100   
End Sub

Sub regBoucle()    '' Rglage du nombre de boucles de l'ADC  
    LcdClear   
    Locate 1,1:Print"Reglage Nb Boucle"
    Locate 2,1:Print "X par :"
    AJUST_VAR(compt,20,1,2,9)
    compt = corect 
    EEwrite(1,compt)
    pause 100
End Sub   


Function QuelTouch() AS Byte     ''Attend la pression d'une touche et Retourne son N 
    STATIC BYTE n                               
    n = 2
    touche = 0 
    DO While n = 2                ' Boucle tant que n=2
           asm clrwdt  ;un os au Chien
        If Bp_p = 0 Then              ' Bouton +
           asm clrwdt  ;un os au Chien
           'Pausebutton()
           Wait Bp_p = 1
           PauseButton()
           touche=2
           Return (touche)
        End if
        If Bp_M = 0 Then              ' Bouton -  
           asm clrwdt  ;un os au Chien 
           'Pausebutton()
           Wait Bp_m = 1 
           PauseButton()
           touche=1 
           Return (touche)
        End if
        If Bp_Ok = 0 Then             ' Bouton Ok
           asm clrwdt  ;un os au Chien 
           'Pausebutton()
           Wait Bp_Ok = 1
           PauseButton()
           touche=3 
           Return (touche)
        End if 
   LOOP
End Function



'...
'--------------------------------------------------------------------------
                   org 0x1800,0x1FFF        'page 3 ***********************
'-------------------------------------------------------------------------- 
Sub Accueil()
     BlLight = 1
     Print "GESTION BATTERIE"   
     Pause 1500
     Locate 2,1
     Print " * Dede.Board * "
     pause 500
     Locate 1,1
     Print " INITIALISATION "
     Pause 500
     BlLight = 0
     End sub   

Sub ReglageHorlog()
    ' LcdClear
     'Locate 1,1
    ' Print " Heure :"
    ' corect = heure
     'AJUST_VAR(heure,23,0,1,9)
     'heure=corect
    ' Pause 200
     LcdClear
     'Locate 1,1
     'Print "Minute :"
    ' corect = minute
    ' AJUST_VAR(minute,59,0,1,9)
    ' minute=corect
     Pause 200
   '  LcdClear
    ' Locate 1,1
    ' Print "  date :"
    ' corect = jour
    ' AJUST_VAR(jour,31,1,1,9)
     'jour=corect
    ' Pause 200
    ' LcdClear
     'Locate 1,1
    ' Print "  Mois :"
    ' corect = mois
    ' AJUST_VAR(mois,12,1,1,9)
     'mois=corect
    ' Pause 200
    ' LcdClear
    ' Locate 1,1
     'Print "  Anne :"
    ' corect = year
     'AJUST_VAR(year,12,1,1,9)
    ' year=corect
    ' Pause 200
End Sub




Function AJUST_VAR(byte v,byte v1,byte v2,byte v3,byte v4) as byte    ' Change la valeur v en + ou en -  et retour avec OK
     STATIC BYTE n                               ' Avec un maxi =  v1 ,un mini v2 ,la ligne v3,la colonne v4
     n = 2
     
    DO While n = 2                ' Boucle tant que n=2
    asm clrwdt  ;un os au Chien                    
    Locate v3,v4                  ' Ligne colonne
    Print v,"    "                ' Valeur Actuelle 
    If v > v1 Then v = 0          ' Ne pas dpasser le maxi
    If v < v2 Then v = v2          ' Ne pas dpasser le maxi
    asm clrwdt  ;un os au Chien                    
    If Bp_p = 0 Then              ' Bouton +
       v = v + 1 
       If v > v1 Then v = 0       ' Ne pas dpasser le maxi
       Do While Bp_p = 0
       asm clrwdt  ;un os au Chien                    
       Loop 
       Pause 5
    End if
    If Bp_M = 0 Then              ' Bouton -     
       v = v - 1
       If v < 0 Then v = 0        ' Empcher la valeur 0
       Do While Bp_m = 0 
       asm clrwdt  ;un os au Chien                    
       Loop 
       Pause 5
    End if
    If Bp_Ok = 0 Then             ' Bouton Ok
       DO While Bp_Ok = 0
       asm clrwdt  ;un os au Chien                    
       Loop
       Pause 5
       corect = v 
       Return (corect)
    End if 
   LOOP 
End Function

Rem   *********   FIN DU PROGRAMME de SEPTEMBRE 2004 **********

End     ''  *********************** Fin du Programme *****************************************
        ''  **********************************************************************************
        ''  ==================================================================================

Sub TestDatas()
    d1=0: d2=0: d3=0: d4=0:pause 1000
    d1=1:d2=1:d3=1
    d4=1:pause 200
    
End Sub



       


' ===========================================Ecriture Lecture ALARMES ===========================

' EEprom de 64k octets
' 1 octet 0  nombre d'alarmes
' alarmes cods sur 5 octets nb  day  mois  heure  minute

Sub EcritAlarm(byte b)
Static byte val,cel
            ' b variable du Numro de l'alarme
    val = 0
    cel = 0
   
    ' Lecture EEPROM 
    val = EERead (0)
    if val = 25 then val = 1     ' + de 25 Enr retour au dbut 
    cel = (val * 5) + 1
        'Ecriture de l'alarme
     GetTime                      'lecture de l'heure
     GetDate                      'lecture de la date  
     EEWrite (cel,b)              'criture du Numro de l'alarme
     cel = cel + 1                'une cellule aprs 
     EEWrite (cel,day)            'criture du jour de l'alarme
     cel = cel + 1                'une cellule aprs 
     EEWrite (cel,month)          'criture du Mois de l'alarme
     cel = cel + 1                'une cellule aprs 
     EEWrite (cel,hour)           'criture de l'heure de l'alarme
     cel = cel + 1                'une cellule apres 
     EEWrite (cel,minute)         'criture de la minute de l'alarme
     EEWrite (0,val + 1)          'criture de la position du prochain enregistrement
End Sub


Sub LectureAlarm(byte b)
    Static Byte Xnb,Xday,Xmonth,Xhour,Xminute,Loc
    Loc = b-1
    'Xnb=0:Xday=0:Xmonth=0:Xhour=0:Xminute=0
    b=(Loc*5)+1
    Xnb = EERead (b)              'Lecture du Numro de l'alarme
    b=b+1                'une cellule aprs 
    Xday = EERead (b)             'Lecture du jour de l'alarme
    b=b+1                'une cellule aprs 
    Xmonth =  EERead (b)           'Lecture du Mois de l'alarme
    b=b+1                'une cellule aprs 
    Xhour =  EERead (b)            'Lecture de l'heure de l'alarme
    b=b+1                'une cellule apres 
    Xminute = EERead (b)          'Lecture de la minute de l'alarme
    LcdClear
    Ligne1
    Loc=Loc+1
    print "Alarme ",Loc," Zone ",Xnb
    Ligne2
    print "du ",Xday,":",Xmonth," a ",Xhour,"h",Xminute,"mn"
    pause (250)    
End Sub    

Sub MenuAlarme()
     static byte val,t,n
     n=2
     BlLight = 1
     val = EERead (0)
     Do While Bp_OK = 1 and Bp_p = 1   'bp relachs
     Loop 
     Ligne1
     LcdClear
     print " *Menu Alarmes* "
     Ligne2
     if val = 0 then 
        Print "*AUCUNE  ALARME*"
        pause 2000
        exit sub
     else
     Fourche(val)
     end if
     pause 2000    ' pour voir
     Ligne1
     Fourche(val)  
     Ligne2
     print "+ Voir OK Retour"
     t=0     
     DO ' Boucle  
     if Bp_OK = 0 then Exit sub
     if Bp_p = 0 then                      ' touche sur plus
        t=t+1 
        LectureAlarm(t)
        pause 500
     end if           
     Loop while t < val + 1
end sub

Sub Fourche(byte c)
     print c," Alarmes      "
End sub                             


































